<?php

namespace Tests\Feature\Http\Controllers;

use App\Models\Token;
use Database\Factories\UserFactory;
use Illuminate\Foundation\Testing\DatabaseMigrations;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Tests\FactoryHelpers\TokenFactoryHelper;
use Tests\TestCase;

class AuthControllerTest extends TestCase
{
    use DatabaseMigrations;
    use RefreshDatabase;

    protected function setUp(): void
    {
        parent::setUp(); // TODO: Change the autogenerated stub
    }

    public function testLoginWithInvalidEmailAndPasswordShouldReturnHttp400(): void
    {
        $response = $this->postJson(route('login'), [
            'email' => '12312312',
            'password' => 123123
        ]);

        $response->assertBadRequest();

        $responseBody = $response->decodeResponseJson();
        $this->assertNotNull($responseBody);
        $this->assertEquals('Bad request', $responseBody['message']);
        $this->assertEquals([
            'email' => ['The email field must be a valid email address.'],
        ], $responseBody['data']);

        # sanity
        $this->assertDatabaseCount('tokens', 0);
    }

    public function testLoginWithValidEmailAndPasswordShouldReturnHttp201(): void
    {
        $user = UserFactory::new()->create(['password' => '123123']);
        $response = $this->postJson(route('login'), [
            'email' => $user->email,
            'password' => '123123'
        ]);

        $response->assertCreated();
        $responseBody = $response->decodeResponseJson();
        $this->assertEquals('Successfully Created', $responseBody['message']);

        $this->assertEquals(1, $user->tokens()->count());
        $this->assertNotNull($responseBody['data']['token']);
        $this->assertEquals($user->tokens()->first()->token, $responseBody['data']['token']);

    }

    public function testLogoutWithValidTokenShouldReturnHttp200(): void {
        $factoryHelper = TokenFactoryHelper::newTokenFactoryHelper();
        $headers = [
            'Authorization' => $factoryHelper->getToken(),
        ];
        $response = $this->deleteJson(route('logout'), [], $headers);

        $response->assertOk();

        $this->assertDatabaseCount('tokens', 0);
    }

}
